Index: /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HL3TreeEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HL3TreeEvaluator.cs	(revision 2392)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/HL3TreeEvaluator.cs	(revision 2393)
@@ -38,5 +38,5 @@
         case EvaluatorSymbolTable.VARIABLE: {
             int row = sampleIndex + currInstr.i_arg1;
-            if (row < 0 || row >= dataset.Rows) throw new InvalidOperationException("Out of range access to dataset row: " + row);
+            if (row < 0 || row >= dataset.Rows) throw new ArgumentException("Out of range access to dataset row: " + row);
             else return currInstr.d_arg0 * dataset.GetValue(row, currInstr.i_arg0);
           }
@@ -46,5 +46,5 @@
         case EvaluatorSymbolTable.DIFFERENTIAL: {
             int row = sampleIndex + currInstr.i_arg1;
-            if (row < 0 || row >= dataset.Rows) throw new InvalidOperationException("Out of range access to dataset row: " + row);
+            if (row < 0 || row >= dataset.Rows) throw new ArgumentException("Out of range access to dataset row: " + row);
             else if (row < 1) return 0.0;
             else {
Index: /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Predictor.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Predictor.cs	(revision 2392)
+++ /trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Predictor.cs	(revision 2393)
@@ -54,5 +54,10 @@
       double[] result = new double[end - start];
       for (int i = 0; i < result.Length; i++) {
-        result[i] = treeEvaluator.Evaluate(i + start);
+        try {
+          result[i] = treeEvaluator.Evaluate(i + start);
+        }
+        catch (ArgumentException) {
+          result[i] = double.NaN;
+        }
       }
       return result;
@@ -63,5 +68,5 @@
       foreach (IFunctionTree ft in FunctionTreeIterator.IteratePrefix(functionTree.FunctionTree)) {
         if (ft is VariableFunctionTree) {
-          VariableFunctionTree variable = (VariableFunctionTree) ft;
+          VariableFunctionTree variable = (VariableFunctionTree)ft;
           inputVariables.Add(variable.VariableName);
         }
Index: /trunk/sources/HeuristicLab.sln
===================================================================
--- /trunk/sources/HeuristicLab.sln	(revision 2392)
+++ /trunk/sources/HeuristicLab.sln	(revision 2393)
@@ -25,6 +25,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Charting-3.3", "HeuristicLab.CEDMA.Charting\3.3\HeuristicLab.CEDMA.Charting-3.3.csproj", "{1BF17271-5350-476A-8F6D-FC74FA3E82CA}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Core-3.3", "HeuristicLab.CEDMA.Core\3.3\HeuristicLab.CEDMA.Core-3.3.csproj", "{C27DDF6C-84DF-45EF-B82F-57A28DD51166}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.CEDMA.Server-3.3", "HeuristicLab.CEDMA.Server\3.3\HeuristicLab.CEDMA.Server-3.3.csproj", "{F05D261A-4F7D-46C9-AB9C-21FD4566D719}"
@@ -530,38 +528,4 @@
 		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Visualization Debug|x86.ActiveCfg = Debug|x86
 		{1BF17271-5350-476A-8F6D-FC74FA3E82CA}.Visualization Debug|x86.Build.0 = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.CEDMA Debug|x64.ActiveCfg = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.CEDMA Debug|x64.Build.0 = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.CEDMA Debug|x86.ActiveCfg = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.CEDMA Debug|x86.Build.0 = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Debug|x64.ActiveCfg = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Debug|x64.Build.0 = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Debug|x86.ActiveCfg = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Debug|x86.Build.0 = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Modeling Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Modeling Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Modeling Debug|x64.ActiveCfg = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Modeling Debug|x86.ActiveCfg = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|Any CPU.Build.0 = Release|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|x64.ActiveCfg = Release|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|x64.Build.0 = Release|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|x86.ActiveCfg = Release|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Release|x86.Build.0 = Release|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.v3.2 Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.v3.2 Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.v3.2 Debug|x64.ActiveCfg = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.v3.2 Debug|x64.Build.0 = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.v3.2 Debug|x86.ActiveCfg = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.v3.2 Debug|x86.Build.0 = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Visualization Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Visualization Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Visualization Debug|x64.ActiveCfg = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Visualization Debug|x64.Build.0 = Debug|x64
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Visualization Debug|x86.ActiveCfg = Debug|x86
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166}.Visualization Debug|x86.Build.0 = Debug|x86
 		{F05D261A-4F7D-46C9-AB9C-21FD4566D719}.CEDMA Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{F05D261A-4F7D-46C9-AB9C-21FD4566D719}.CEDMA Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -4068,5 +4032,4 @@
 		{6D9564BB-956D-4808-8F92-AA7F776F90A5} = {410732DB-725A-4824-896B-C298978343C0}
 		{1BF17271-5350-476A-8F6D-FC74FA3E82CA} = {410732DB-725A-4824-896B-C298978343C0}
-		{C27DDF6C-84DF-45EF-B82F-57A28DD51166} = {410732DB-725A-4824-896B-C298978343C0}
 		{F05D261A-4F7D-46C9-AB9C-21FD4566D719} = {410732DB-725A-4824-896B-C298978343C0}
 		{B462D3CC-8866-42F0-9832-AD0967613B72} = {410732DB-725A-4824-896B-C298978343C0}